function eigvals = mypolyeig(A)

neig = 300;

if iscell(A)
	% m - degree of the polynomial
	m = length(A) - 1;
	n = size(A{1},1);

	LA = zeros(m*n);
	for k = 1:m
		if (k <= m-1)
			LA((k-1)*n+1:k*n,k*n+1:(k+1)*n) = eye(n);
		end
		
		LA((m-1)*n+1:m*n,(k-1)*n+1:k*n) = A{k};
	end

	LB = eye(m*n);
	LB((m-1)*n+1:m*n,(m-1)*n+1:m*n) = -A{m+1};

	eigvals = eig(LA,LB);
else
	[n,n2] = size(A);

	if (n <= neig)
		eigvals = eig(A);
	else
		eigvals = eigs(A,1,'lr')*ones(n,1);
	end
end